/*"Gear Indicator Dll": Simple OutGauge server for Directx 9 games
 * Author: Vladimir Kadlec
 *         vladimirkadlec@gmail.com
 *         http://www.fi.muni.cz/~xkadlec
 */
/*
This file is part of Gear Indicator Dll.

Gear Indicator Dll is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Gear Indicator Dll is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Gear Indicator Dll; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include <stdio.h>
#include <stdarg.h>
#include <windows.h>
#include "log.h"

//static FILE *logfile = stderr;
void warning (char *s, ...) {
	va_list arg;
    va_start (arg, s);
    fprintf (logfile, "WARNING: ");
    vfprintf (logfile, s, arg);
    va_end(arg);
    fflush (logfile);
}

void error (char *s, ...) {
	va_list arg;
    va_start (arg, s);
    fprintf (logfile, "ERROR: ");
    vfprintf (logfile, s, arg);
    va_end(arg);
    fflush (logfile);
}

void log (char *s, ...) {
	va_list arg;
    va_start (arg, s);
    vfprintf (logfile, s, arg);
    va_end(arg);
    fflush (logfile);
}

void set_logfile (char *filename) {
FILE *f;
     fclose (logfile);
     f = fopen (filename, "w+");
     if (f == NULL) {
           ::ExitProcess(0);
     }
     logfile = f;
}
void close_logfile() {
     fclose (logfile);
}
